<script lang="ts">
  import { type C2GamesUser } from '@auth/keycloak';
  import oidc from '@auth/keycloak'
  import { goto } from '$app/navigation';
  import { onMount } from 'svelte';
  import { Spinner } from "@sveltestrap/sveltestrap";

  // if not in a browser, this will cause an error (during pre-rendering/sso)
  onMount(async () => {
    let user: C2GamesUser | undefined;
    let redirect = '/';
    try {
      console.debug('ssoRedirect: attempting to parse browser url');
      user = (await oidc.signinCallback()) as C2GamesUser | undefined;
      console.log('user', user);
      if (user?.url_state) {
        redirect = user.url_state;
      }
    } catch {
      console.warn('ssoRedirect: Failed to initialize OIDC Signin Callback, user will be redirected');
      await goto('/');
    }

    console.debug(`ssoRedirect: redirecting authenticated=${oidc.authenticated} location=${redirect}`);
    await goto(redirect);
  });

  /**
   * This page is used in two ways:
   * 1. Within an iframe to handle a OIDC signinCallback during the silentSignin flow
   * 2. As a redirect the user will be sent to after a successful OIDC signinCallback
   *
   * In the latter case, the user does see this page for a few moments,
   * but they should be quickly redirected to a page within the (app) group.
   */
</script>

<div class="container d-flex flex-column mx-auto items-center justify-center p-12">
  <Spinner />
  <p>Loading...</p>
</div>
